% Script to test sparse SVD decompostion
close all;


rho=[5 2 2 1 1 1];
maxcount=6;
eps=1e-6;

%load('hastiemat','HastieMat');
%A=HastieMat;
load('pitprops');
A=corr_matrix_pitprops;

count=0;n=size(A,1);
res=[];vals=[];eigs=[];mxs=[];nrms=[];
mat=A;lvl=0;
while all([max(max(mat))>lvl,count<maxcount])
    count=count+1;
    [resvec,resval,ovals]=PrimalDec(mat,rho(count));
    mat=mat-resval*resvec*resvec';
    eigs=[eigs,eig(mat)];
    nrms=[nrms,norm(mat)];
    mxs=[mxs,max(max(mat))];
    vals=[vals,ovals];
    res=[res,resvec];
end
res(:,1:6)

% Plot results ...
SPCAvars=[28 42 55.3 62.7 69.5 75.8]/100; % From Hastie et al.
SPCAcards=[7 11 15 16 17 18];

% Plot variances
figure;
cumvals=[vals(1)];
for i=2:6
    cumvals=[cumvals,cumvals(i-1)+vals(i)];
end
plot(cumvals/trace(A))
hold on;
plot(SPCAvars,'-k')
hold off;

% Plot cardinality
cumcards=[cardinal(res(:,1),eps)];
for i=2:6
    cumcards=[cumcards,cumcards(i-1)+cardinal(res(:,i),eps)];
end
figure;
plot(cumcards)
hold on;
plot(SPCAcards,'-k')
hold off;