function [resvec,resval,oval]=PrimalDec(A,k)
% Computes sparsest pseudo eigenvector of A

n=size(A,1);

% Solve SDP relaxation of max eigenvalue problem with l1 penalty
euc=eye(n^2);
amat=[0,zeros(1,2*n^2),vec(eye(n))'];
bvec=[1];
for i=1:n^2
    amat=[amat;[0,euc(i,:),-euc(i,:),euc(i,:)]];
    bvec=[bvec;0];
end
amat=[amat;[1,ones(1,2*n^2),zeros(1,n^2)]];
bvec=[bvec;k];
objvec=-[0,zeros(1,2*n^2),vec(A)'];

% SEDUMI paprameters
clear('Ksedumi');
Ksedumi.l=2*n^2+1;
Ksedumi.s=n;
pars.fid=0;

% Launch SEDUMI solver
[xsol,ysol]=sedumi(amat,bvec,objvec,Ksedumi,pars);

% Return results...
matsol=mat(xsol((2*n^2+2):(3*n^2+1)));
oval=-objvec*xsol;
[vecsol,diagbuf]=eig(matsol);
diagsol=diag(diagbuf);
resvec=vecsol(:,n);
resval=resvec'*A*resvec;