% disp(' ');
load('ionosphere.dat');
modiono = ionosphere(:,[1,3:end]); % the second attribute is zero for every data point, so I removed it. 
data = modiono';

%td = SPECTF';
%data = td([2:end],:);
%data = [data; td(1,:)]


[A,B] = formmatrix(data);
rho=1; % 5         % Penalty factor controlling sparsity (large rho => sparse sol)
maxiter=10;    % Maximum Number of Iterations
tol=5e-2;           % Target precision (DEBUG: change precision target settings)
p=50;n=size(B,1);

% Parameters that can be modified here and affect the matrix exponential computation using partial eigenvalue decomposition
numeigs=4;      % # of eigenvalues to take at a time in partial eig decomposition
addeigs=4;      % # of eigenvalues to add at a time when taking more than numeigs
maxit_eigs=500; % maximum # of iterations in partial eig decomposition using MATLAB's eigs
checkgap=1;     % # of iterations between checking gap (can be more often than info)
propeigs=.10;   % percentage of eigenvalues partial eig decomposition will retrieve before reverting to full eig decomposition
check_for_more_eigs=10;     % # of iterations between checks for using more eigenvalues when only one eigenvalue currently is being used (checked in util.c)
check_for_unnec_eigs=10;   % # of iterations between checks for how many eigenvalues being used are necessary for partial eigenvalue decomposition (checked in util.c)
info=10;
algo=5;

% Compute initial basis (random)
randn('state',25);
[R,T]=qr(randn(p,p));


% Run the mex file
	[U,X,x,F,iter,dualitygap,cputime,perceigs] = sparse_rank_one_mex(A,B,R(:,1:n),rho,tol,maxiter,info,algo,numeigs,addeigs,maxit_eigs,checkgap,propeigs,check_for_more_eigs,check_for_unnec_eigs);
%[Y2,U2,y2,obj2] = RotGenEigenValue(A,B,R(:,1:n),rho,tol,maxiter);
%clear sparse_rank_one_mex;